

# DescribeThingType
<a name="API_DescribeThingType"></a>

Gets information about the specified thing type.

Requires permission to access the [DescribeThingType](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_DescribeThingType_RequestSyntax"></a>

```
GET /thing-types/thingTypeName HTTP/1.1
```

## URI Request Parameters
<a name="API_DescribeThingType_RequestParameters"></a>

The request uses the following URI parameters.

 ** [thingTypeName](#API_DescribeThingType_RequestSyntax) **   <a name="iot-DescribeThingType-request-uri-thingTypeName"></a>
The name of the thing type.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `[a-zA-Z0-9:_-]+`   
Required: Yes

## Request Body
<a name="API_DescribeThingType_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_DescribeThingType_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "thingTypeArn": "string",
   "thingTypeId": "string",
   "thingTypeMetadata": { 
      "creationDate": number,
      "deprecated": boolean,
      "deprecationDate": number
   },
   "thingTypeName": "string",
   "thingTypeProperties": { 
      "mqtt5Configuration": { 
         "propagatingAttributes": [ 
            { 
               "connectionAttribute": "string",
               "thingAttribute": "string",
               "userPropertyKey": "string"
            }
         ]
      },
      "searchableAttributes": [ "string" ],
      "thingTypeDescription": "string"
   }
}
```

## Response Elements
<a name="API_DescribeThingType_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [thingTypeArn](#API_DescribeThingType_ResponseSyntax) **   <a name="iot-DescribeThingType-response-thingTypeArn"></a>
The thing type ARN.  
Type: String

 ** [thingTypeId](#API_DescribeThingType_ResponseSyntax) **   <a name="iot-DescribeThingType-response-thingTypeId"></a>
The thing type ID.  
Type: String

 ** [thingTypeMetadata](#API_DescribeThingType_ResponseSyntax) **   <a name="iot-DescribeThingType-response-thingTypeMetadata"></a>
The ThingTypeMetadata contains additional information about the thing type including: creation date and time, a value indicating whether the thing type is deprecated, and a date and time when it was deprecated.  
Type: [ThingTypeMetadata](API_ThingTypeMetadata.md) object

 ** [thingTypeName](#API_DescribeThingType_ResponseSyntax) **   <a name="iot-DescribeThingType-response-thingTypeName"></a>
The name of the thing type.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `[a-zA-Z0-9:_-]+` 

 ** [thingTypeProperties](#API_DescribeThingType_ResponseSyntax) **   <a name="iot-DescribeThingType-response-thingTypeProperties"></a>
The ThingTypeProperties contains information about the thing type including description, a list of searchable thing attribute names, and MQTT5 configuration.  
Type: [ThingTypeProperties](API_ThingTypeProperties.md) object

## Errors
<a name="API_DescribeThingType_Errors"></a>

 ** InternalFailureException **   
An unexpected error has occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request is not valid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The specified resource does not exist.    
 ** message **   
The message for the exception.
HTTP Status Code: 404

 ** ServiceUnavailableException **   
The service is temporarily unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The rate exceeds the limit.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** UnauthorizedException **   
You are not authorized to perform this operation.    
 ** message **   
The message for the exception.
HTTP Status Code: 401

## See Also
<a name="API_DescribeThingType_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iot-2015-05-28/DescribeThingType) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iot-2015-05-28/DescribeThingType) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iot-2015-05-28/DescribeThingType) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iot-2015-05-28/DescribeThingType) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iot-2015-05-28/DescribeThingType) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iot-2015-05-28/DescribeThingType) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iot-2015-05-28/DescribeThingType) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iot-2015-05-28/DescribeThingType) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iot-2015-05-28/DescribeThingType) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iot-2015-05-28/DescribeThingType) 